## med-fichier 3.3.1+repack

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.10 FATAL_ERROR)
PROJECT(MEDFile CXX C)

## The following signature is still buggy as of CMake 2.8.11 - 
## the OPTIONAL is not considered.
## See http://www.cmake.org/Bug/view.php?id=10227
#ENABLE_LANGUAGE(Fortran OPTIONAL)

INCLUDE(CheckLanguage)
CHECK_LANGUAGE(Fortran)
IF(CMAKE_Fortran_COMPILER)
  ENABLE_LANGUAGE(Fortran)
ELSE()
  MESSAGE(STATUS "No Fortran support")
ENDIF()

## Version number 
SET(MED_NUM_MAJEUR  3)
SET(MED_NUM_MINEUR  3)
SET(MED_NUM_RELEASE 1)

SET(MED_STR_VERSION "${MED_NUM_MAJEUR}.${MED_NUM_MINEUR}.${MED_NUM_RELEASE}")

SET(LONG_OR_INT int)

## User options:
OPTION (MEDFILE_BUILD_TESTS "Build MED-file tests" ON)
IF (MEDFILE_BUILD_TESTS)
  ENABLE_TESTING()
ENDIF()
OPTION (MEDFILE_BUILD_SHARED_LIBS "Build MED-file shared libraries" ON)
OPTION (MEDFILE_BUILD_STATIC_LIBS "Build MED-file static libraries" OFF)
OPTION (MEDFILE_INSTALL_DOC "Install pre-built documentation" ON)
OPTION (MEDFILE_BUILD_PYTHON "Build Python bindings (needs SWIG)" OFF)

# Option checking.
IF(WIN32 AND MEDFILE_BUILD_SHARED_LIBS AND MEDFILE_BUILD_STATIC_LIBS)
  MESSAGE(WARNING "On Windows you can not build shared and static libraries at the same time! "
  "Disabling STATIC build.")
  SET(MEDFILE_BUILD_STATIC_LIBS OFF)
ENDIF()
IF(NOT (MEDFILE_BUILD_SHARED_LIBS OR MEDFILE_BUILD_STATIC_LIBS))
  MESSAGE(WARNING "You must select to build either STATIC or SHARED libs. Setting "
  "MEDFILE_BUILD_SHARED_LIBS to ON.")
  SET(MEDFILE_BUILD_SHARED_LIBS ON)
ENDIF()
IF(MEDFILE_BUILD_SHARED_LIBS AND MEDFILE_BUILD_STATIC_LIBS)
  MESSAGE(WARNING "You are building both static and shared libs. This might create conflicts when " 
  "linking projects to med-file. You have been warned.")
ENDIF()

## Useful macros
LIST(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/config/cmake_files")
INCLUDE(medMacros)

## Version number
#MED_EXTRACT_AUTOTOOLS_VERSION(${PROJECT_SOURCE_DIR}/configure.ac MED_NUM_MAJEUR MED_NUM_MINEUR MED_NUM_RELEASE)
#SET(MED_STR_VERSION "${MED_NUM_MAJEUR}.${MED_NUM_MINEUR}.${MED_NUM_RELEASE}")

## Platform specific flags (windows)
IF(WIN32)
  ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS)  # To disable windows warnings for strcpy, fopen, ...
  ADD_DEFINITIONS(-D_SCL_SECURE_NO_WARNINGS)  # To disable windows warnings std::copy, std::transform, ...
  ADD_DEFINITIONS(-DWNT -DWIN32)
  ADD_DEFINITIONS(-D_WIN32_WINNT=0x0500) # Windows 2000 or later API is required
  ADD_DEFINITIONS(-DPPRO_NT_CALL) # For windows system functions call

  IF(NOT MINGW)
    # Needed to avoid a seg fault at runtime!
    # The variable is not very well documented but seems to exist
    SET(CMAKE_Fortran_FLAGS  "/iface:mixed_str_len_arg ${CMAKE_Fortran_FLAGS}")
    ADD_DEFINITIONS(-DPPRO_NT) # For windows medfile function nammes
  ENDIF()

ELSE()
  # Ensure intermediate OBJECT libraries and static libs are built with -fPIC:
  SET(CMAKE_POSITION_INDEPENDENT_CODE ON)
ENDIF(WIN32)

## Directories
IF(WIN32 AND NOT CYGWIN)
   SET(INSTALL_CMAKE_CONFIG_DIR cmake)
ELSE()
   SET(INSTALL_CMAKE_CONFIG_DIR share/cmake/${PROJECT_NAME})
ENDIF()
SET(INSTALL_INCLUDE_DIR include)

## Pre-requisites detection
# Detect HDF5 first to potentially retrieve MPI automatically:
MED_FIND_HDF5()
MED_FIND_MPI()

IF(MEDFILE_BUILD_PYTHON)
  FIND_PACKAGE(SWIG REQUIRED)
  INCLUDE(${SWIG_USE_FILE})
  FIND_PACKAGE(PythonLibs REQUIRED)
  FIND_PACKAGE(PythonInterp REQUIRED)  # to get version string ...
ENDIF()

## Creation of files med_config.h.cmake
MED_CREATE_CONFIG_FILES()

## Check for various functions
MED_CHECK_HEADERS()
MED_CHECK_FUNCTIONS()
MED_CHECK_SIZE()
MED_C_FORTRAN_INTERFACE()
MED_TIME_SYS_TIME()

## Configure the files created above
CONFIGURE_FILE("${PROJECT_BINARY_DIR}/include/med_config.h.cmake" "${PROJECT_BINARY_DIR}/include/med_config.h")
CONFIGURE_FILE("${PROJECT_BINARY_DIR}/include/2.3.6/med_config.h.cmake" "${PROJECT_BINARY_DIR}/include/2.3.6/med_config.h")

## Sources 
ADD_SUBDIRECTORY(include)
ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(tools)
IF(MEDFILE_BUILD_TESTS)
  ADD_SUBDIRECTORY(tests)
ENDIF()
IF(MEDFILE_BUILD_PYTHON)
  ADD_SUBDIRECTORY(python)
ENDIF()

## Installation of the doc
IF(MEDFILE_INSTALL_DOC)
  INSTALL(DIRECTORY doc DESTINATION ${CMAKE_INSTALL_PREFIX}/share)
ENDIF()

#######################
## Configuration export
#######################
INCLUDE(CMakePackageConfigHelpers)

# Project name, upper case
STRING(TOUPPER ${PROJECT_NAME} PROJECT_NAME_UC)

# Detect if we are built as a sub-project in a bigger source tree:
IF("${CMAKE_SOURCE_DIR}" STREQUAL "${PROJECT_SOURCE_DIR}")
  SET(_BUILT_AS_SUB FALSE)
  MESSAGE(STATUS "Configuring ${PROJECT_NAME} standalone.")
ELSE()
  MESSAGE(STATUS "Configuring ${PROJECT_NAME} as a sub-project. No conf files will be installed.")
  SET(_BUILT_AS_SUB TRUE)
ENDIF()

# Add all targets to the build-tree export set if we are *not*  
# built as a sub-folder of a bigger project.
IF(NOT _BUILT_AS_SUB)
  IF(CMAKE_Fortran_COMPILER_WORKS)
    SET(_fortLib med medfwrap)
    SET(_fortLibS med_static medfwrap_static)
  ELSE()
    SET(_fortLib "")
    SET(_fortLibS "")
  ENDIF()
  
  IF(MEDFILE_BUILD_STATIC_LIBS)
    EXPORT(TARGETS medC_static ${_fortLibS}
      FILE ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake)
  ENDIF()
  IF(MEDFILE_BUILD_SHARED_LIBS) 
    EXPORT(TARGETS medC ${_fortLib}
      APPEND FILE ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Targets.cmake)
  ENDIF()
  
ENDIF()

# Create the configuration files:
#   - in the build tree:
SET(HDF5_ROOT_DIR "${HDF5_ROOT_DIR}")  # ensure the var exists, even if blank
SET(MPI_ROOT_DIR "${MPI_ROOT_DIR}")    # ensure the var exists, even if blank
SET(CONF_INCLUDE_DIRS "${PROJECT_SOURCE_DIR}/include" "${PROJECT_BINARY_DIR}/include")
CONFIGURE_PACKAGE_CONFIG_FILE(config/cmake_files/${PROJECT_NAME}Config.cmake.in 
    ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
    INSTALL_DESTINATION "${INSTALL_CMAKE_CONFIG_DIR}"
    PATH_VARS CONF_INCLUDE_DIRS INSTALL_CMAKE_CONFIG_DIR CMAKE_INSTALL_PREFIX HDF5_ROOT_DIR MPI_ROOT_DIR)

#   - in the install tree:
#       Get the relative path of the include directory so 
#       we can register it in the generated configuration files:
SET(CONF_INCLUDE_DIRS "${CMAKE_INSTALL_PREFIX}/${INSTALL_INCLUDE_DIR}")
CONFIGURE_PACKAGE_CONFIG_FILE(config/cmake_files/${PROJECT_NAME}Config.cmake.in 
    ${PROJECT_BINARY_DIR}/to_install/${PROJECT_NAME}Config.cmake
    INSTALL_DESTINATION "${INSTALL_CMAKE_CONFIG_DIR}"
    PATH_VARS CONF_INCLUDE_DIRS INSTALL_CMAKE_CONFIG_DIR CMAKE_INSTALL_PREFIX HDF5_ROOT_DIR MPI_ROOT_DIR)

WRITE_BASIC_PACKAGE_VERSION_FILE(${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
    VERSION ${MED_STR_VERSION}
    COMPATIBILITY AnyNewerVersion)
  
# Install the CMake configuration files:
INSTALL(FILES
  "${PROJECT_BINARY_DIR}/to_install/${PROJECT_NAME}Config.cmake"
  "${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake"
  DESTINATION "${INSTALL_CMAKE_CONFIG_DIR}")

# Install the export set for use within the install-tree
IF(NOT _BUILT_AS_SUB)
  INSTALL(EXPORT medfileTargets DESTINATION "${INSTALL_CMAKE_CONFIG_DIR}" FILE ${PROJECT_NAME}Targets.cmake)
ENDIF()

=== include/CMakeLists.txt ===
ADD_SUBDIRECTORY(2.3.6)

CONFIGURE_FILE(med.h.in ${CMAKE_CURRENT_BINARY_DIR}/med.h @ONLY)
CONFIGURE_FILE(med_utils.h.in ${CMAKE_CURRENT_BINARY_DIR}/med_utils.h @ONLY)
CONFIGURE_FILE(med_parameter.hf.in ${CMAKE_CURRENT_BINARY_DIR}/med_parameter.hf @ONLY)

CONFIGURE_FILE(H5public_extract.h.in ${CMAKE_CURRENT_BINARY_DIR}/H5public_extract.h @ONLY)

SET(medC_HEADERS_H
  ${CMAKE_CURRENT_BINARY_DIR}/med.h
  ${CMAKE_CURRENT_BINARY_DIR}/med_utils.h
  medlibrary.h
  medfile.h
  medmesh.h
  medfamily.h
  medfield.h
  medprofile.h
  medlocalization.h
  medparameter.h
  medequivalence.h
  medinterp.h
  medfilter.h
  medsubdomain.h
  medlink.h
  med_err.h
  med_exit_if.h
  med_proto.h
  medC_win_dll.h
  MEDerreur.hxx
)

SET(medF_HEADERS_H
  med.hf    
  med.hf77
  med.hf90
  ${CMAKE_CURRENT_BINARY_DIR}/med_parameter.hf
)

INSTALL(FILES ${medC_HEADERS_H} DESTINATION ${INSTALL_INCLUDE_DIR})
INSTALL(FILES ${medF_HEADERS_H} DESTINATION ${INSTALL_INCLUDE_DIR})

=== python/CMakeLists.txt ===
INCLUDE(${SWIG_USE_FILE})

INCLUDE_DIRECTORIES(
  ${PYTHON_INCLUDE_DIRS}
  ${PROJECT_SOURCE_DIR}/include
  ${PROJECT_BINARY_DIR}/include
  ${HDF5_INCLUDE_DIRS}
  ${MPI_INCLUDE_DIRS}
  )

SET(_swig_files 
  medenum_module.i
  medenumtest_module.i
  medequivalence_module.i
  medfamily_module.i
  medfield_module.i
  medfile_module.i
  medfilter_module.i
  medinterp_module.i
  medlibrary_module.i
  medlink_module.i
  medlocalization_module.i
  medmesh_module.i
  medparameter_module.i
  medprofile_module.i
  medsubdomain_module.i
)

IF(APPLE)
  SET(PYTHON_LIBRARIES "-undefined dynamic_lookup")
ENDIF(APPLE)

SET(_link_libs
  medC
  ${PYTHON_LIBRARIES}
  )

SET(_install_dir lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages/med)

# Ensure we will be able to run the Python tests from the build tree by outputing
# files into the package folder:
SET(CMAKE_SWIG_OUTDIR med)
FILE(COPY "__init__.py" DESTINATION ${PROJECT_BINARY_DIR}/python/med)

FOREACH(f ${_swig_files})
  SET_SOURCE_FILES_PROPERTIES(${f} PROPERTIES CPLUSPLUS ON SWIG_FLAGS "-shadow")

  # Get module name
  STRING(REPLACE "_module.i" "" _module_name ${f})

  # SWIG source file and module name differ - the following needs to be
  # set to avoid unnecessary rebuilds:
  SET_SOURCE_FILES_PROPERTIES(${f} PROPERTIES SWIG_MODULE_NAME ${_module_name})

  SET(SWIG_MODULE_libbatch_EXTRA_DEPS ${SWIG_LB_DPYS})
  SWIG_ADD_MODULE(${_module_name} python ${f})
  SWIG_LINK_LIBRARIES(${_module_name} ${_link_libs})

  INSTALL(TARGETS ${SWIG_MODULE_${_module_name}_REAL_NAME} DESTINATION ${_install_dir})
  INSTALL_AND_COMPILE_PYTHON_FILE("${CMAKE_CURRENT_BINARY_DIR}/med/${_module_name}.py" ${_install_dir})
  
ENDFOREACH()

INSTALL_AND_COMPILE_PYTHON_FILE("${CMAKE_CURRENT_SOURCE_DIR}/__init__.py" ${_install_dir})

=== src/CMakeLists.txt ===
INCLUDE_DIRECTORIES(
  ${HDF5_INCLUDE_DIRS}
  ${MPI_INCLUDE_DIRS})

# On Win platform, we need to make sure symbols are properly exported in
# the intermediary OBJECT targes built in the sub-directories:
# The definition "-D<target>_EXPORTS" is normally added automatically by CMake
# when building Win DLL,
# but this doesn't work when using intermediary targets (ADD_LIBRARY(... OBJECT ...)
IF(WIN32)
  ADD_DEFINITIONS(-DmedC_EXPORTS)
ENDIF()
  
# Specific include logic - see CMakeLists.txt inside:
ADD_SUBDIRECTORY("2.3.6")

# Important: the following include comes AFTER the subdirectory 2.3.6
# to ensure the include works properly (2.3.6 includes are specific)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/include 
    ${PROJECT_SOURCE_DIR}/include)

# Get pure C intermediary targets:
ADD_SUBDIRECTORY(hdfi)
ADD_SUBDIRECTORY(ci)
ADD_SUBDIRECTORY(misc)

IF(CMAKE_Fortran_COMPILER_WORKS)
  # Build intermediate targets _cfi, _cfi_static and _fi:
  ADD_SUBDIRECTORY(cfi)
  ADD_SUBDIRECTORY(fi)

  SET(medfort_wrap_SOURCES
    MEDiteratorsF.f 
    $<TARGET_OBJECTS:_fi236> 
    $<TARGET_OBJECTS:_fi>
    $<TARGET_OBJECTS:_cfi236> 
    $<TARGET_OBJECTS:_cfi>
  )
  
  SET(medfort_static_wrap_SOURCES
    MEDiteratorsF.f 
    $<TARGET_OBJECTS:_fi236> 
    $<TARGET_OBJECTS:_fi>
    $<TARGET_OBJECTS:_cfi236_static> 
    $<TARGET_OBJECTS:_cfi_static>
  )
ENDIF()

SET(medC_SOURCES
  MEDiterators.c
  $<TARGET_OBJECTS:_ci236>
  $<TARGET_OBJECTS:_hdfi236>
  $<TARGET_OBJECTS:_misc236>
  $<TARGET_OBJECTS:_med236>
  $<TARGET_OBJECTS:_ci>
  $<TARGET_OBJECTS:_misc>
  $<TARGET_OBJECTS:_hdfi>  
)

SET(medC_static_SOURCES
  MEDiterators.c
  $<TARGET_OBJECTS:_ci236_static>
  $<TARGET_OBJECTS:_hdfi236_static>
  $<TARGET_OBJECTS:_misc236_static>
  $<TARGET_OBJECTS:_med236_static>
  $<TARGET_OBJECTS:_ci_static>
  $<TARGET_OBJECTS:_misc_static>
  $<TARGET_OBJECTS:_hdfi_static>  
)

########################### Pure C stuff ###################################
############################################################################

### Installation preparation:
SET(_export_group "medfileTargets")

######### Shared Libraries ##########
IF(MEDFILE_BUILD_SHARED_LIBS)
  ADD_LIBRARY(medC SHARED ${medC_SOURCES})
  TARGET_LINK_LIBRARIES(medC ${HDF5_LIBRARIES} ${MPI_LIBS})
  MED_SET_DEFINITIONS(medC NOGDI)
  
  INSTALL(TARGETS medC EXPORT ${_export_group} DESTINATION lib)  
ENDIF()

######### Static Libraries ##########
##
## Target names are suffixed with "_static" but file 
## names remain the same.
 
IF(MEDFILE_BUILD_STATIC_LIBS)
  ADD_LIBRARY(medC_static STATIC ${medC_SOURCES})
  SET_TARGET_PROPERTIES(medC_static PROPERTIES OUTPUT_NAME medC)
  TARGET_LINK_LIBRARIES(medC_static ${HDF5_LIBRARIES} ${MPI_LIBS})
  MED_SET_DEFINITIONS(medC_static NOGDI)
  
  INSTALL(TARGETS medC_static EXPORT ${_export_group} DESTINATION lib)
ENDIF()

########################### Fortran stuff ###################################
#############################################################################
IF(CMAKE_Fortran_COMPILER_WORKS)
  
  ######### Shared Libraries ##########
  IF(MEDFILE_BUILD_SHARED_LIBS)
    ## Intermediate library - this is unavoidable 
    ## if we want the Fortran wrapper to build correctly under win.
    ADD_LIBRARY(medfwrap STATIC ${medfort_wrap_SOURCES})
    TARGET_LINK_LIBRARIES(medfwrap medC)
    INSTALL(TARGETS medfwrap EXPORT medfileTargetsF DESTINATION lib)

    # Add Shared MED library
    ADD_LIBRARY(med SHARED MEDiterators.c)
    TARGET_LINK_LIBRARIES(med medfwrap)    
   
    # Install only the resulting library:
    INSTALL(TARGETS med EXPORT medTargetsF DESTINATION lib)
  ENDIF()

  ######### Static Libraries ##########
  ##
  ## Target names are suffixed with "_static" but file 
  ## names remain the same.
  IF(MEDFILE_BUILD_STATIC_LIBS)
    ## Intermediate library - this is unavoidable 
    ## if we want the Fortran wrapper to build correctly under win.
    ADD_LIBRARY(medfwrap_static STATIC ${medfort_wrap_SOURCES})
    SET_TARGET_PROPERTIES(medfwrap_static PROPERTIES OUTPUT_NAME medfwrap)
    TARGET_LINK_LIBRARIES(medfwrap_static medC_static)
    INSTALL(TARGETS medfwrap_static EXPORT medfileTargetsF DESTINATION lib)
    
    # Add Static MED library
    ADD_LIBRARY(med_static STATIC MEDiterators.c)
    SET_TARGET_PROPERTIES(med_static PROPERTIES OUTPUT_NAME med)
    TARGET_LINK_LIBRARIES(med_static medfwrap_static)

    # Install only the resulting library:  
    INSTALL(TARGETS med_static EXPORT medfileTargetsF DESTINATION lib)
  ENDIF()
  
ENDIF(CMAKE_Fortran_COMPILER_WORKS)

=== tests/python/CMakeLists.txt ===
SET(_tst_scripts
  test10.py
  test11.py
  test12.py
  test13.py
  test1.py
  test21.py
  test22.py
  test23.py
  test24.py
  test27.py
  test28.py
  test29.py
  test30.py
  test2.py
  test3.py
  test4.py
  test5.py
  test6.py
  test7.py
  test8.py
  test9.py
  test_medfile.py
  test_medmesh.py
)

SET(_to_install
  ${_tst_scripts}
  UseCase_MEDinterp_1.py
  UseCase_MEDinterp_2.py
  UseCase_MEDinterp_3.py
)

FOREACH(_s IN LISTS _tst_scripts)
  STRING(REPLACE ".py" "_Python" _tst_name ${_s})
  FILE(COPY ${_s} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
  ADD_TEST(NAME ${_tst_name}
           COMMAND "/usr/bin/env" "PYTHONPATH=${PROJECT_BINARY_DIR}/python" "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_BINARY_DIR}/${_s}")
ENDFOREACH()

INSTALL(FILES ${_to_install} DESTINATION bin/testpy)

=== tools/medimport/CMakeLists.txt ===
INCLUDE_DIRECTORIES(
  ${HDF5_INCLUDE_DIRS}
  ${MPI_INCLUDE_DIRS}
)

# Needed by all targets:
ADD_DEFINITIONS(-DMED_MESGERR_FOR_TOOLS)
INCLUDE_DIRECTORIES(include)

# Those two need specific includes:
ADD_SUBDIRECTORY("2.1.x")
ADD_SUBDIRECTORY("2.3.1")

# For the rest:
INCLUDE_DIRECTORIES("${PROJECT_BINARY_DIR}/include"
    "${PROJECT_SOURCE_DIR}/include")

ADD_SUBDIRECTORY("2.3.6")
ADD_SUBDIRECTORY("3.0.0")
ADD_SUBDIRECTORY("3.1.0")
ADD_SUBDIRECTORY("3.2.0")

SET(medimporttop_SOURCES
  libmedimport.c
  MAJ_version.c
)

SET(medimport_SOURCES
  $<TARGET_OBJECTS:_medimport21x>
  $<TARGET_OBJECTS:_medimport231>
  $<TARGET_OBJECTS:_medimport236>
  $<TARGET_OBJECTS:_medimport300>
  $<TARGET_OBJECTS:_medimport310>
  $<TARGET_OBJECTS:_medimport320>
  ${medimporttop_SOURCES}
)

SET(medimport_static_SOURCES
  $<TARGET_OBJECTS:_medimport21x_static>
  $<TARGET_OBJECTS:_medimport231_static>
  $<TARGET_OBJECTS:_medimport236_static>
  $<TARGET_OBJECTS:_medimport300_static>
  $<TARGET_OBJECTS:_medimport310_static>
  $<TARGET_OBJECTS:_medimport320_static>
  ${medimporttop_SOURCES}
)

# Shared version
IF(MEDFILE_BUILD_SHARED_LIBS)
  ADD_LIBRARY(medimportengine SHARED ${medimport_SOURCES})
  IF(WIN32)
    MED_SET_DEFINITIONS(medimportengine medimport_EXPORTS MEDIMPORTCXX_DLL_EXPORTS)
  ENDIF()
  TARGET_LINK_LIBRARIES(medimportengine medC)
  SET_TARGET_PROPERTIES(medimportengine PROPERTIES OUTPUT_NAME medimport)
  INSTALL(TARGETS medimportengine DESTINATION lib)
  SET(_lib_to_link "medimportengine")
ENDIF()

# Static version
IF(MEDFILE_BUILD_STATIC_LIBS)
  ADD_LIBRARY(medimportengine_static STATIC ${medimport_static_SOURCES})
  TARGET_LINK_LIBRARIES(medimportengine_static medC_static)
  MED_SET_DEFINITIONS(medimportengine_static MED3_USESTATIC)
  SET_TARGET_PROPERTIES(medimportengine_static PROPERTIES OUTPUT_NAME medimport)
  INSTALL(TARGETS medimportengine_static DESTINATION lib)
  # Give precendence to the shared object for the linking of 
  # the executable medimport:
  IF(NOT _lib_to_link)
    SET(_lib_to_link "medimportengine_static")
  ENDIF()
ENDIF()

# Only build the medimport executable on certain
# conditions to avoid a nasty name conflict:
IF(NOT (WIN32 AND MEDFILE_BUILD_STATIC_LIBS))
  ADD_EXECUTABLE(medimport medimportcxx.cxx)
  IF(MEDFILE_BUILD_STATIC_LIBS)
    MED_SET_DEFINITIONS(medimport MED3_USESTATIC)
  ENDIF()
  TARGET_LINK_LIBRARIES(medimport ${_lib_to_link})
    
  # Installation
  INSTALL(TARGETS medimport DESTINATION bin )  
ENDIF()

INSTALL(FILES include/medimport_win_dll.h include/MEDimport.h include/MEDimport.hxx include/medimportcxx_win_dll.h DESTINATION include)

=== debian/changelog ===
med-fichier (3.3.1+repack-4ubuntu1) disco; urgency=medium

  * d/t/build{1,2}: Move -lmedC after file that needs it to fix failure with
    ld --as-needed.

 -- Logan Rosen <logan@ubuntu.com>  Sun, 18 Nov 2018 21:34:35 -0500

med-fichier (3.3.1+repack-4) unstable; urgency=medium

  * Disable tests/parallel on mips as well 

 -- Gilles Filippini <pini@debian.org>  Sat, 21 Jul 2018 14:40:47 +0200

med-fichier (3.3.1+repack-3) unstable; urgency=medium

  * upload to unstable (previous upload erroneously targetted
    experimental)

 -- Gilles Filippini <pini@debian.org>  Sat, 14 Jul 2018 14:47:20 +0200

med-fichier (3.3.1+repack-2) unstable; urgency=medium

  * Fix autopkgtest: use mpicc instread of gcc

 -- Gilles Filippini <pini@debian.org>  Sun, 08 Jul 2018 17:20:46 +0200

med-fichier (3.3.1+repack-1) unstable; urgency=medium

  * Repack source tarball: remove doxygen generated files
  * Build-Depends-Indep: doxygen
  * override_dh_auto_*-indep targets to build the doc
  * Fix doc-base file references
  * Re-enable mpi-support for arm64
  * Upload to unstable

 -- Gilles Filippini <pini@debian.org>  Thu, 05 Jul 2018 21:44:02 +0200

med-fichier (3.3.1-4) experimental; urgency=medium

  * libmedc-dev: install missing include files

 -- Gilles Filippini <pini@debian.org>  Mon, 02 Jul 2018 23:24:52 +0200

med-fichier (3.3.1-3) experimental; urgency=medium

  * New patch fix-tests-c-test11.patch: fix FTBFS on mips due to
    incorrect data type in printf for MED_INT64
  * New patch disable-parallel-test-on-some-archs.patch: disable
    tests/parallel for arches armel, hppa, hurd-i386, and ia64; it
    randomly hangs and I'm not sure it's related to med-fichier

 -- Gilles Filippini <pini@debian.org>  Thu, 07 Jun 2018 20:50:27 +0200

med-fichier (3.3.1-2) experimental; urgency=medium

  * Patch hdf5-1.10-support.patch: fix ISCRUTE_id() as well
  * New patch fix-typo-in-tests.patch to fix typos in some test scripts

 -- Gilles Filippini <pini@debian.org>  Fri, 01 Jun 2018 01:23:43 +0200

med-fichier (3.3.1-1) experimental; urgency=medium

  * Team upload
  * New upstream release
  * Disable python module
  * Drop patches fixed upstream:
    - hdf5_link.patch
    - ppc64el-support.patch
    - tests-ignore-native-char-impl.patch
  * Disable patch clang-ftbfs.diff (need some testing)
  * Update patches:
    - hdf5-1.10-support.patch: many chuncks applied upstream, but still
      a lot to do, mainly for Fortran sources
    - parallel-test-seed.patch

 -- Gilles Filippini <pini@debian.org>  Thu, 31 May 2018 17:30:09 +0200

med-fichier (3.0.6-12) unstable; urgency=medium

  * Team upload.
  * [4e2709a] Set version 4.1.3
  * [361c3fe] Remove outdated testsuite-field in d/control
  * [5218d20] Update VCS-fields
  * [f7d40ff] Set compat-level 11
  * [33167e8] Remove uneeded build-depends
  * [ed5f433] Remove myself from uploaders

 -- Anton Gladky <gladk@debian.org>  Tue, 20 Mar 2018 21:57:05 +0100

med-fichier (3.0.6-11) unstable; urgency=medium

  * Team upload.

  [ Gilles Filippini ]
  * Do not ignore testcase failures
  * Temporarily disabling MPI support for arm64 (not functionnal
    currently)
  * New patches:
    - hdf5-1.10-support.patch: fix HDF5 1.10 support (closes: #855130)
    - parallel-test-seed.patch: use the same random() seed for each MPI
      process
    - tests-ignore-native-char-impl.patch: patch some testcase scripts
      to ignore differences from arch specific native char types
  * Drop patch fix-fid-type-in-medequivinfo.patch now included into
    hdf5-1.10-support.patch

  [ Anton Gladky ]
  * Add --oversubscribe option to mpi to escape fails if slots are 
    not available

 -- Anton Gladky <gladk@debian.org>  Mon, 20 Feb 2017 16:37:45 +0100

med-fichier (3.0.6-10.1) unstable; urgency=medium

  * Non-maintainer upload
  * New patch fix-fid-type-in-medequivinfo.patch to fix FTBFS with
    HDF5 1.10 (closes: #841964)

 -- Gilles Filippini <pini@debian.org>  Sun, 30 Oct 2016 18:06:27 +0100

med-fichier (3.0.6-10) unstable; urgency=medium

  * [f6af4e3] Fix autopkgtest.
  * [7603827] Apply cme fix dpkg.

 -- Anton Gladky <gladk@debian.org>  Sun, 04 Sep 2016 20:06:34 +0200

=== debian/control ===
Source: med-fichier
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Aurelien Jarno <aurel32@debian.org>,
           "Adam C. Powell, IV" <hazelsct@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 11),
               gfortran,
               hdf5-tools (>= 1.8.13+docs-12),
               libhdf5-mpi-dev (>= 1.8.13+docs-12),
               mpi-default-dev,
               mpi-default-bin,
               libtool,
               tk
Build-Depends-Indep: doxygen
Standards-Version: 4.1.3
Vcs-Browser: https://salsa.debian.org/science-team/med-fichier
Vcs-Git: https://salsa.debian.org/science-team/med-fichier.git
Homepage: http://www.code-aster.org/outils/med/

Package: libmed-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libmed1v5 (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Development files for libmed
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.

Package: libmed-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Documentation for the MED-fichier library
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package provides the documentation for the MED-fichier library
 (in French).

Package: libmed-tools
Architecture: any
Multi-Arch: foreign
Section: science
Depends: tk,
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Runtime tools to handle MED files
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package contains runtime tools for med-fichier:
  - mdump: a tool to dump MED files
  - xmdump: graphical version of mdump.
  - medconforme: a tool to validate a MED file
  - medimport: a tool to convert a MED v2.1 or v2.2 file into a MED v2.3
    file

Package: libmed1v5
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: libmed-doc,
          libmed-tools
Pre-Depends: ${misc:Pre-Depends}
Breaks: libmed1
Replaces: libmed1
Description: Library to exchange meshed data (Fortran version)
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package contains the MED-fichier runtime library (Fortran version).

Package: libmedc-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libhdf5-mpi-dev,
         libmedc1v5 (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Development files for libmedc
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package contains the header files and static library needed to
 compile applications that use libmedC.

Package: libmedc1v5
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: libmed-doc,
          libmed-tools
Pre-Depends: ${misc:Pre-Depends}
Breaks: libmedc1
Replaces: libmedc1
Description: Library to exchange meshed data (C version)
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package contains the MED-fichier runtime library (C version).

Package: libmedimport-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libmedc-dev,
         libmedimport0v5 (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Provides: libmedimportcxx-dev
Description: Development files for libmedimport0
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package contains the header files and static library needed to
 compile applications that use libmedimport, including C++ applications.

Package: libmedimport0v5
Architecture: any
Multi-Arch: same
Section: libs
Depends: libmedc1v5,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: libmed-doc,
          libmed-tools
Pre-Depends: ${misc:Pre-Depends}
Breaks: libmedimport0
Replaces: libmedimport0
Description: Library to import old version files
 MED-fichier (Modélisation et Echanges de Données, in English Modelisation
 and Data Exchange) is a library to store and exchange meshed data or
 computation results. It uses the HDF5 file format to store the data.
 .
 This package contains the library able to import old version files (C
 version).

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

# Which MPI implementation?
# set ARCH_DEFAULT_MPI_IMPL
include /usr/share/mpi-default-dev/debian_defaults

export OMPI_MCA_orte_rsh_agent=/bin/false                #workaround to start MPI-applications in chroot
export DEB_CPPFLAGS_MAINT_APPEND := -I/usr/include/$(ARCH_DEFAULT_MPI_IMPL) -DOMPI_SKIP_MPICXX=1 -DMPICH_SKIP_MPICXX=1
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

override_dh_auto_clean:
	[ ! -f doc/html.dox/Makefile ] || make -C doc/html.dox maintainer-clean-local
	dh_auto_clean

override_dh_auto_configure:
	HDF5_VERSION=11000 dh_auto_configure -- --disable-python --with-hdf5=/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/$(ARCH_DEFAULT_MPI_IMPL) --with-hdf5-bin=/usr/bin

override_dh_auto_build-indep:
	dh_auto_build --builddirectory=doc/html.dox -- html-local
	dh_auto_build --builddirectory=doc

override_dh_auto_install-arch:
	dh_auto_install
	rm -rf $(CURDIR)/debian/tmp/usr/bin/test* \
         $(CURDIR)/debian/tmp/usr/bin/usescases \
         $(CURDIR)/debian/tmp/usr/bin/unittests

override_dh_auto_install-indep:
	dh_auto_install --builddirectory=doc

override_dh_install:
	dh_install
	rm -f debian/libmedc-dev/usr/include/*import*

override_dh_auto_test-arch:
	MPIEXEC="mpiexec --allow-run-as-root --oversubscribe -np " dh_auto_test --max-parallel=1

override_dh_auto_test-indep:

=== debian/watch ===
version=4
http://www.salome-platform.org/downloads/current-version \
  http://files.salome-platform.org/Salome/other/med-([\d\.]*).tar.gz \
  debian debian/orig-tar.sh

## med-fichier 4.0.0%2Brepack

=== python/CMakeLists.txt ===
--- 
+++ 
@@ -24,6 +24,7 @@
   medparameter_module.i
   medprofile_module.i
   medsubdomain_module.i
+  medstructelement_module.i
 )
 
 IF(APPLE)

=== doc/dox/CMakeLists.txt ===
if(MEDFILE_BUILD_DOC)
#-- Configure the Template Doxyfile for our specific project

  FILE(READ ${PROJECT_SOURCE_DIR}/doc/dox/MEDfile.als            DOXYMEDFILE               )
  FILE(READ ${PROJECT_SOURCE_DIR}/doc/dox/MEDmesh.als            DOXYMEDMESH               )
  FILE(READ ${PROJECT_SOURCE_DIR}/doc/dox/MEDsupportMesh.als     DOXYMEDSUPPORTMESH        )
  FILE(READ ${PROJECT_SOURCE_DIR}/doc/dox/MEDfilter.als          DOXYMEDFILTER             )
  FILE(READ ${PROJECT_SOURCE_DIR}/doc/dox/MEDlibrary.als         DOXYMEDLIBRARY            )
  FILE(READ ${PROJECT_SOURCE_DIR}/doc/dox/MEDfield.als           DOXYMEDFAMILY             )
  FILE(READ ${PROJECT_SOURCE_DIR}/doc/dox/MEDfamily.als          DOXYMEDEQUIVALENCE        )
  FILE(READ ${PROJECT_SOURCE_DIR}/doc/dox/MEDequivalence.als     DOXYMEDFIELD              )
  FILE(READ ${PROJECT_SOURCE_DIR}/doc/dox/MEDlink.als            DOXYMEDLINK               )
  FILE(READ ${PROJECT_SOURCE_DIR}/doc/dox/MEDjoint.als           DOXYMEDJOINT              )
  FILE(READ ${PROJECT_SOURCE_DIR}/doc/dox/MEDlocalization.als    DOXYMEDLOCALIZATION       )
  FILE(READ ${PROJECT_SOURCE_DIR}/doc/dox/MEDinterp.als          DOXYMEDSTRUCTELEMENT      )
  FILE(READ ${PROJECT_SOURCE_DIR}/doc/dox/MEDstructElement.als   DOXYMEDINTERP             )
  FILE(READ ${PROJECT_SOURCE_DIR}/doc/dox/MEDparameter.als       DOXYMEDPARAMETER          )
  FILE(READ ${PROJECT_SOURCE_DIR}/doc/dox/MEDprofile.als         DOXYMEDPROFILE            )

  CONFIGURE_FILE(aliases.als.cmake.in
                  ${PROJECT_BINARY_DIR}/doc/dox/aliases.als  @ONLY IMMEDIATE)

  FILE(READ ${PROJECT_BINARY_DIR}/doc/dox/aliases.als   DOXYALIASES )
#Be careful : The cmake doc generation doesn't work yet !
  CONFIGURE_FILE(Doxyfile.cfg.cmake.in
    ${PROJECT_BINARY_DIR}/doc/dox/Doxyfile.cfg  @ONLY IMMEDIATE)

endif(MEDFILE_BUILD_DOC)
